// MouseDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Mouse.h"
#include "MouseDlg.h"
#include ".\mousedlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMouseDlg dialog



CMouseDlg::CMouseDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMouseDlg::IDD, pParent)
	, m_iPrevX(0)
	, m_iPrevY(0)
	, m_bMyCursor(false)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMouseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMouseDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_SETCURSOR()
END_MESSAGE_MAP()


// CMouseDlg message handlers

BOOL CMouseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	//    
	m_bMyCursor = false;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMouseDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMouseDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMouseDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMouseDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	//  :     
	// /    

	// ,     
	if((nFlags & MK_LBUTTON) == MK_LBUTTON){
		//    
		CClientDC dc(this);

		//    (solid, 10 pixels, red)
		CPen newPen(PS_SOLID,
					10,
					RGB(255, 0, 0));
		//    
		dc.SelectObject(&newPen);

		//      
		//	dc.SetPixel(point.x, 
		//				point.y, 
		//				RGB(0, 0, 0));

		//       
		dc.MoveTo(m_iPrevX, m_iPrevY); //   
		dc.LineTo(point.x, point.y); //   

		//       
		m_iPrevX = point.x;
		m_iPrevY = point.y;
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CMouseDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	//      
	m_iPrevX = point.x;
	m_iPrevY = point.y;

	CDialog::OnLButtonDown(nFlags, point);
}

void CMouseDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	char ch; //   
	HCURSOR hCursor = 0; //  ,   
	HCURSOR hPrevCursor = 0; //   

	//     
	ch = char(nChar); // 
	bool endFlag = false; // 	

	switch(ch){
		//    
		case 'A': //  
			hCursor = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
			break;
			
		//     
		case 'B': //  
			hCursor = AfxGetApp()->LoadStandardCursor(IDC_IBEAM);
			break;
			
		//     
		case 'C': //  
			hCursor = AfxGetApp()->LoadStandardCursor(IDC_WAIT);
			break;
			
		//     
		case 'E': //  
			hCursor = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
			endFlag = true;
	}

	hPrevCursor = hCursor ? SetCursor(hCursor) : 0;
	if(hCursor){//      
		DestroyCursor(hPrevCursor);
		hCursor = 0;
		m_bMyCursor = true; //  
	}

	if(endFlag)
		OnOK();

	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

BOOL CMouseDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	// TODO: Add your message handler code here and/or call default
	if(m_bMyCursor) 
		return TRUE; //     

	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}
